=== debian/changelog ===
openmprtl (5.0.1-1) unstable; urgency=medium

  * New usptream release
  * Standards-Version: 4.1.3

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 07 Jan 2018 16:39:52 +0100

openmprtl (5.0-2) unstable; urgency=medium

  * Fix the symbol file for arm64

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 25 Nov 2017 18:33:22 +0100

openmprtl (5.0-1) unstable; urgency=medium

  * New upstream release (LP: #1717127)
  * New symbols:
    - __kmpc_atomic_fixed1u_sub_rev_fp
    - __kmpc_atomic_fixed2u_sub_rev_fp
    - __kmpc_atomic_fixed4u_sub_rev_fp
    - __kmpc_atomic_fixed8u_sub_rev_fp
    - __kmpc_task_reduction_get_th_data
    - __kmpc_task_reduction_init
  * Standards-Version updated to 4.1.1
  * priority-extra-is-replaced-by-priority-optional fixed
  * Add a "Suggests: libomp-doc" from the dev lib (Closes: #849605)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 25 Nov 2017 14:43:05 +0100
