=== debian/control ===
Source: openmprtl
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 8.0.0), doxygen, gfortran, cmake,
 libffi-dev [mips mipsel mips64 mips64el armel armhf]
Standards-Version: 4.1.3
Section: libs
Homepage: http://openmp.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/openmprtl/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/openmprtl/trunk/

Package: libiomp-dev
Section: libdevel
Architecture: any
Depends: libomp-dev (= ${binary:Version}), ${misc:Depends}
Description: Intel OpenMP runtime - dev package - transition package
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.
 .
 This package has been replaced by the LLVM sources. This is the Intel version
 moved under the LLVM umbrella. This is a dependency package.

Package: libomp-dev
Section: libdevel
Architecture: any
Depends: libomp5 (= ${binary:Version}), ${misc:Depends}
Suggests: libomp-doc
Replaces: libiomp-dev (<< 3.7-1)
Breaks: libiomp-dev (<< 3.7-1)
Description: LLVM OpenMP runtime - dev package
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.

Package: libiomp5
Section: libs
Architecture: any
Depends: libomp5, ${shlibs:Depends}, ${misc:Depends}
Description: Intel OpenMP runtime - transition package
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.
 .
 This package has been replaced by the LLVM sources. This is the Intel version
 moved under the LLVM umbrella. This is a dependency package.

Package: libomp5
Multi-Arch: same
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libiomp5 (<< 3.7-1)
Breaks: libiomp5 (<< 3.7-1)
Description: LLVM OpenMP runtime
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.

Package: libiomp5-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libomp5 (= ${binary:Version})
Description: Intel OpenMP runtime - Debug transition package
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.
 .
 This package has been replaced by the LLVM sources. This is the Intel version
 moved under the LLVM umbrella. This is a dependency package.


Package: libomp5-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libomp5 (= ${binary:Version})
Replaces: libiomp5-dbg (<< 3.7-1)
Breaks: libiomp5-dbg (<< 3.7-1)
Description: LLVM OpenMP runtime - Debug package
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.

Package: libiomp-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, libomp-doc
Description: Intel OpenMP runtime - Documentation -  Transition package
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.
 .
 This package has been replaced by the LLVM sources. This is the Intel version
 moved under the LLVM umbrella. This is a dependency package.

Package: libomp-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery
Replaces: libiomp-doc (<< 3.7-1)
Breaks: libiomp-doc (<< 3.7-1)
Description: LLVM OpenMP runtime - Documentation
 The runtime is the part of the OpenMP implementation that your code is
 linked against, and that manages the multiple threads in an OpenMP program
 while it is executing.
 .
 This package contains the documentation of this package.
