=== debian/watch ===
version=3
http://llvm.org/releases/download.html .*/openmp-(.*).src.tar.xz
